# monaco-jsx-highlighter

An extensible library to highlight JSX syntax for the Monaco Editor using JsCodeShift.
 It exposes its AST, so you can add your own syntax-based highlights.  

## Dependencies
It requires [`monaco-editor`](https://www.npmjs.com/package/monaco-editor) and [`jscodeshift`](https://www.npmjs.com/package/jscodeshift), for convenience, they are listed as peer dependencies.

## Installation

Install the package in your project directory with:

```sh
// with npm
npm install monaco-jsx-syntax-highlighter

// with yarn
yarn add monaco-jsx-syntax-highlighter
```

## Usage

```JavaScript
//this should be already in your code
import monaco from 'monaco';
import {default as j} from 'jscodeshift';
// importing this package
import MonacoJSXHighlighter from 'monaco-jsx-syntax-highlighter';

const elem = document.getElementById("editor");
const monacoEditor = monaco.editor.create(elem, {
    value: 'const AB=<A x={d}><B>{"hello"}</B></A>;',
    language: 'javascript'
});

// triggering the highlighter after each code change
const monacoJSXHighlighter = new MonacoJSXHighlighter(monaco, j, monacoEditor);
editor.onDidChangeModelContent(() => {
monacoJSXHighlighter.colorizeCode(monacoEditor.getValue());
});

//optional: adding custom highlighting after the JSX highlighting
monacoJSXHighlighter.afterColorize((
                JSXDecoratorIds, // array with the decorators created by colorize
                ast, // the ast generate by  JsCodeShift
                JSXTypes, // the JSX Syntax types and their monaco CSS classnames.
                locToMonacoRange // converts JsCodeShift locations to Monaco Ranges
)=>{
//... your code
});



 
```
